Enemys = {}
ThePlayer = nil
BackGround = nil
WaveNum = 6
KillCount = 0

function NewZombie(z)
	if z < 1 then z = 1 end
	for i=0,z,1 do
		local theta = math.random(360)
		local mag = math.random(1000,1500)
		theta = theta*math.pi/180
		local x = mag*math.cos(theta) + 512
		local y = mag*math.sin(theta) + 512
		table.insert(Enemys,1,Zombie:new(x,y))
	end
end

function NewMiniBoss(z)
	for i=0,z,1 do
		local theta = math.random(360)
		local mag = math.random(1000,1500)
		theta = theta*math.pi/180
		local x = mag*math.cos(theta) + 512
		local y = mag*math.sin(theta) + 512
		table.insert(Enemys,1,MiniBoss:new(x,y))
	end
end

function NewWave()
	NewZombie(2^(WaveNum/4))
	if WaveNum%2 == 0 then
		NewMiniBoss(2^((WaveNum-6)/4)/3)
	end
	WaveNum = WaveNum + 1
end

function GetweightedNum(N)
	if N < 7 then
		return 0
	elseif N < 14 then
		return 0
	elseif N < 14 then
		return 0
	elseif N < 21 then
		return 0
	elseif N < 28 then
		return 0
	elseif N < 40 then
		return 0
	elseif N < 48 then
		return 0
	elseif N <= 49 then
		return 0
	end
end

function Init()
	math.randomseed(os.time())
	love.mouse.setVisible(false)
	love.graphics.setFont(GameFont)
	love.graphics.setBackgroundColor(255,255,255)
	ThePlayer = Player:new(300,400)
	NewWave()
	Music2:setLooping(true)
	love.audio.play(Music2)
end

function love.load()
	love.graphics.setCaption( "Zombie Game" )
	BackGround = love.graphics.newImage("Texture/BackGround.png")
	LeftArm =  love.graphics.newImage("Texture/LeftArm.png")
	RightArm =  love.graphics.newImage("Texture/RightArm.png")
	ArmsBatch[0] = love.graphics.newSpriteBatch( LeftArm, 1000 )
	ArmsBatch[1] = love.graphics.newSpriteBatch( RightArm, 1000 )
	ArmsBatch[2] = love.graphics.newSpriteBatch( LeftArm, 1000 )
	ArmsBatch[3] = love.graphics.newSpriteBatch( RightArm, 1000 )
	BloodSpater[0] = love.graphics.newImage("Texture/BS1.png")
	BloodSpater[1] = love.graphics.newImage("Texture/BS2.png")
	BloodSpater[2] = love.graphics.newImage("Texture/BS3.png")
	BloodSpater[3] = love.graphics.newImage("Texture/BS4.png")
	BloodSpater[4] = love.graphics.newImage("Texture/BS5.png")
	Fire[0] = love.graphics.newImage("Texture/FB1.png")
	Fire[1] = love.graphics.newImage("Texture/FB2.png")
	Fire[2] = love.graphics.newImage("Texture/FB3.png")
	Fire[3] = love.graphics.newImage("Texture/FB4.png")
	Fire[4] = love.graphics.newImage("Texture/FB5.png")
	SpatterBatch[0] = love.graphics.newSpriteBatch( BloodSpater[0], 100000 )
	SpatterBatch[1] = love.graphics.newSpriteBatch( BloodSpater[1], 100000 )
	SpatterBatch[2] = love.graphics.newSpriteBatch( BloodSpater[2], 100000 )
	SpatterBatch[3] = love.graphics.newSpriteBatch( BloodSpater[3], 100000 )
	SpatterBatch[4] = love.graphics.newSpriteBatch( BloodSpater[4], 100000 )
	LoadSpatter()
	PlayerTex = love.graphics.newImage("Texture/Player.png")
	ZombieTex = love.graphics.newImage("Texture/Zombie.png")
	MiniBossTex = love.graphics.newImage("Texture/MiniBoss.png")
	ShootSound1 = love.audio.newSource("Audio/Shoot1.mp3", "static")
	PlayerHit = love.audio.newSource("Audio/Hurt.mp3", "static")
	PlayerHit:setPitch(0.5)
	Music2 = love.audio.newSource("Music/prondisk.xm")
	GameFont = love.graphics.newFont("Other/Arcade.ttf", 30)
	Init()
end

function love.run()
    if love.load then love.load() end
	local GameFlag = true
	while MainLoop() do
		love.graphics.setColor(0,0,0)
		love.graphics.setColorMode("modulate")
		GameFlag = true
		while GameFlag do
			love.timer.step()
			love.graphics.clear()
			love.graphics.print("your dead, press <enter> to play\n again and <q> or <escape> to quit",50,200)
			for e,a,b,c in love.event.poll() do
				if love.keyboard.isDown("q") or love.keyboard.isDown("escape") then
					return
				end
				if love.keyboard.isDown("return") then
					local Size = #Enemys
					for i=0,Size,1 do
						table.remove(Enemys,#Enemys)
					end
					ThePlayer= Player:new(300,400)
					WaveNum = 0
					NewWave()
					SpatterBatch[0]:clear()
					SpatterBatch[1]:clear()
					SpatterBatch[2]:clear()
					SpatterBatch[3]:clear()
					SpatterBatch[4]:clear()
					ArmsBatch[0]:clear()
					ArmsBatch[1]:clear()
					ArmsBatch[2]:clear()
					ArmsBatch[3]:clear()
					GameFlag = false
				end
				if e == "q" then
					if not love.quit or not love.quit() then
						love.audio.stop()
						return
					end
				end
				love.handlers[e](a,b,c)
			end
			love.graphics.present()
		end
		love.graphics.setColorMode("replace")
	end
end
