-- putting these here because I'm lazy
local MuzzleFlashes = {
   love.graphics.newImage("Texture/MuzzleFlash1.png"),
   love.graphics.newImage("Texture/MuzzleFlash2.png"),
   love.graphics.newImage("Texture/MuzzleFlash3.png"),
}
local BulletSprite = love.graphics.newImage('Texture/fire.png')

local function normalizedVector(x1, y1, x2, y2)
   local vx, vy = x2-x1, y2-y1
   local len = math.sqrt(vx^2 + vy^2)
   return vx/len, vy/len
end

local particles = love.graphics.newParticleSystem( BulletSprite, 115 )
local flashmax = .1 -- how long to show each flash
local flashtime = 0  -- how long the current flash has left
local muzzleoffset = 50 -- distance from player center to business end of gun

particles:setBufferSize( 115 )
particles:setEmissionRate( 5000 )
particles:setLifetime( 0.1 )
particles:setParticleLife( 0.1 )
particles:setColor( 55, 10, 10, 255, 55, 55, 10, 255 )
particles:setSize( 0.06, 0.1, 1 )
particles:setSpeed( 6000, 10000  )
particles:setSpread( 0 )

MuzzleFlash = {}

function MuzzleFlash:update(dt)
   particles:update(dt)
   flashtime = flashtime - dt
   if flashtime > 0 then
      local px, py, mx, my = ThePlayer.x,ThePlayer.y,love.mouse.getX(),love.mouse.getY()
      local vx, vy = normalizedVector(px, py, mx, my)
      x = px + vx * muzzleoffset
      y = py + vy * muzzleoffset
      angle = math.atan2(vy,vx)
      particles:setPosition(px + vx, py + vy)
      particles:setDirection(angle)
   end
end

function MuzzleFlash:start()
   if flashtime <= 0 then
      flashtime = flashmax
      image = MuzzleFlashes[math.random(1,#MuzzleFlashes)]
      self:update(0)
      particles:start()
   end
end

function MuzzleFlash:draw()
   if flashtime > 0 then
      local r, g, b, a = love.graphics.getColor()
      love.graphics.setColor(255,255,255)
      love.graphics.draw(particles, 0, 0)
      love.graphics.draw(image, x, y, angle, .7, .7, 32, 32)
      love.graphics.setColor(r,g,b,a)
   end
end
